/* -*- linux-c -*- */
/*
 *
 *   Copyright (c) International Business Machines  Corp., 2000
 *
 *   This program is free software;  you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY;  without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 *   the GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program;  if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

/* linux/driver/evms/evms_ecr.c
 *
 * EVMS - Cluster enablement (ECR) module
 *
 */


#include <linux/kernel.h> 
#include <linux/module.h>
#include <linux/init.h>
#include <linux/types.h>
#include <linux/evms/evms_ecr.h>

#define LOG_PREFIX "ecr: "


/*
 *  ecr_group_join
 */
ecr_group_t ecr_group_join(char *group_name, ecr_table_t *f_table, 
		   ecr_cred_t * cred, size_t size, ecr_instance_t *instance)
{
	/* dummy */
	return ECR_FAIL;
}




/*
 *  ecr_group_leave
 */
void  ecr_group_leave(ecr_group_t group)
{
	/* dummy */
	return;
}



/*
 * ecr_group_send
 */
int ecr_group_send(ecr_group_t group, ecr_nodeid_t node, void *message,
		size_t size, ecr_instance_t *instance, 
		void callback(int ret, ecr_instance_t *instance))
{
	/* dummy */
	return ECR_FAIL;
}



/*
 * ecr_group_send_wait
 */
int ecr_group_send_wait(ecr_group_t group, ecr_nodeid_t node, void *message,
		size_t size, int *ret)
{
	/* dummy */
	*ret = ECR_FAIL;
	return ECR_FAIL;
}



/*
 * ecr_group_broadcast
 */
int ecr_group_broadcast(ecr_group_t group, void *message, size_t size,
			ecr_instance_t *instance,
			void callback(u_char ret, ecr_instance_t *instance))
{
	/* dummy */
	return ECR_FAIL;
}



/*
 * ecr_group_broadcast_wait
 */
int ecr_group_broadcast_wait(ecr_group_t group, void *message, size_t size,
			u_char *ret)
{
	/* dummy */
	*ret = ECR_FAIL;
	return ECR_FAIL;
}



/*
 * ecr_group_atomic_execute
 */
int ecr_group_atomic_execute(ecr_group_t group, void *message, size_t size,
			ecr_instance_t *instance,
			void callback(ecr_instance_t *instance))
{
	/* dummy */
	return ECR_FAIL;
}



/*
 * ecr_group_atomic_execute_wait
 */
int ecr_group_atomic_execute_wait(ecr_group_t group, void *message, size_t size)
{
	/* dummy */
	return ECR_FAIL;
}



/*
 * ecr_group_success_response
 */
void ecr_group_success_response(ecr_message_t *handle)
{
	/* dummy */
	return;
}




/*
 * ecr_group_failure_response
 */
void ecr_group_failure_response(ecr_message_t *handle, int ret)
{
	/* dummy */
	return;
}
			


/*
 * ecr_lock_create
 */
ecr_lock_t ecr_lock_create(char *lockname)
{
	/* dummy */
	return ECR_FAIL;
}

/*
 * ecr_lock
 */
int  ecr_lock(ecr_lock_t lock, u_int64_t start, u_int64_t length, 
		ecr_lock_mode_t mode, u_char flag)
{
	/* dummy */
	return ECR_FAIL;
}



/*
 * ecr_unlock
 */
int ecr_unlock(ecr_lock_t lock, u_int64_t start, u_int64_t length)
{
	/* dummy */
	return ECR_FAIL;
}
		

/********************************************************/
/* Required Module Entry Point:                         */
/*      ecr_init()                                        */
/********************************************************/

static int __init ecr_init(void)
{
        /* dummy */
	return 0;
}

static void __exit ecr_exit(void)
{
	return;
}

module_init(ecr_init);
module_exit(ecr_exit);
#ifdef MODULE_LICENSE
MODULE_LICENSE("GPL");
#endif

